# -*- coding: utf-8 -*-
import multiprocessing
import sys
import time
import locale

tabChar = list("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 ")
nbProcess = 4
verbose = False

class App():
	def __init__(self):

		## La liste contenant nos object Processe
		self.processes = list()
		self.queue = multiprocessing.Queue()
		self.infoQueue = multiprocessing.Queue()
		self.found = False
		self.appTime = time.time()
		global nbProcess
		global verbose
		
		for i in range(0,nbProcess):
			p=ProcessBrurteForce(self.queue, i,nbProcess , "totor","",4,verbose)
			self.processes.append(p)
			
	def run(self):
		for proc in self.processes:
			proc.start()
			
		procAlive=True
		totalMotParSecondes =0
		while procAlive:
			totalMotParSecondes =0
			procAlive =False
			for proc in self.processes:
				#proc.join()
				resultat = self.queue.get()
				if resultat[0]== 0 : 
					if resultat[1] == True :
						#print("RESULT: %s" % resultat[2])
						self.displayResult(resultat[2])
						for proc in self.processes:
							proc.terminate()
						sys.exit()
				elif resultat[0] == 1:
					WordsSeconds = round(resultat[1]/resultat[2])
					totalMotParSecondes = totalMotParSecondes + WordsSeconds
					locale.setlocale(locale.LC_ALL, 'french_france')
					WordsSeconds = locale.format('%d', WordsSeconds, grouping=True)
					print(resultat[4]+" : " + '{:>30}'.format(WordsSeconds) + " Mots/s   \tMot actuel : " + resultat[3])
					
				else:
					print("/!\ useCase" + resultat[0] +"non traité") 
					
					
				#on verifie qu'il y a encore des process en cours (il n'y ap aps de do while en python
				if proc.is_alive():
					procAlive =True
			if verbose:
				locale.setlocale(locale.LC_ALL, 'french_france')
				totalMotParSecondes = locale.format('%d', totalMotParSecondes, grouping=True)
				print("Mots Par Secondes :    " +'{:>30}'.format(totalMotParSecondes)+ " Mots/s")
					
		return None
		
	def displayResult(self,passTrouve):
		if(time.time() - self.appTime) > 60 :
			seconds = time.time() - self.appTime
			m, s = divmod(seconds, 60)
			h, m = divmod(m, 60)
			d ,h = divmod(h, 24)
			if d != 0:
				print("Found ! : " + passTrouve +" en " + "%d:%02d:%02d:%02d" % (d,h, m, s))
			elif h != 0 :
				print("Found ! : " + passTrouve +" en " + "%d:%02d:%02d" % (h, m, s))
			else:
				print("Found ! : " + passTrouve +" en " + "%d:%02d" % (m, s))
		else:
			print("Found ! : " + passTrouve +" en " + str(time.time() - self.appTime) + " secondes")
		
class ProcessBrurteForce(multiprocessing.Process):
	def __init__(self,queue, idx, nbInstence,password, clef, limite, verbose):
		super().__init__()
		self.queue = queue
		self.idx = idx
		self.nbInstence = nbInstence
		
		#la queue contien 3 valeur :int useCase = 0, boolean found, list passTrouve
		#la queue contien 5 valeur :int useCase = 1,  nbMots, time secondes , list motEnCours nom du thread
			#useCase = 0, on remonte les information contenant le mot Trouvé ou non  
			#useCase = 1, on remonte des information sur les performances
		#gestion du temps
		self.nbMot = 0
		self.procTime = time.time()
		self.verbose = verbose

		self.password = password
		self.clef = clef
		self.limite = limite
		self.tabPass = list("a")
		self.isFound  = False
		return
		
	def testSpeed(self):
		self.nbMot = self.nbMot+1
		if  (time.time() - self.procTime) > 5 :
			self.queue.put([1,self.nbMot,time.time() - self.procTime, "".join(self.tabPass),multiprocessing.current_process().name])
			self.nbMot = 0
			self.procTime = time.time()
			
	def run(self):
		#print(multiprocessing.current_process().name + "\tStart")
		found , passTrouve = self.checkChar(0)
		if not found:
			while not found and len(self.tabPass) < self.limite:
				self.tabPass = self.tabPass + list('a')
				found,passTrouve =self.recursiveFunction(len(self.tabPass)-1)
				if found == True : 
					passTrouve = "".join(self.tabPass)
					
			if not found :
				indexMin = round((len(tabChar)/self.nbInstence)*self.idx)
				indexMax = round(indexMin + (len(tabChar)/self.nbInstence))
				self.tabPass = self.tabPass + list(tabChar[indexMin])
				#print(multiprocessing.current_process().name + "\tRange : " + str(indexMin) + " - " + str(indexMax))
				for i in range(indexMin,indexMax):
					self.tabPass[len(self.tabPass)-1] = tabChar[i]
					found,passTrouve =self.recursiveFunction(len(self.tabPass)-2)
					if found == True:
						#la queue contien 2 valeur :  boolean found, list passTrouve
						#la queue contien 4 valeur :  nbMots, time secondes , list motEnCours nom du thread
						self.queue.put([0,found, passTrouve])
						return None

		print(multiprocessing.current_process().name + "\tStop")
		#la queue contien 2 valeur :  boolean found, list passTrouve
		#la queue contien 4 valeur :  nbMots, time secondes , list motEnCours nom du thread
		self.queue.put([0,found, passTrouve])
		return None
	
	def recursiveFunction(self,index):
		found , passTrouve = self.checkChar(index)
		if index > 0 and not found:
			for char in tabChar :
				self.tabPass[index] = char
				found, passTrouve =self.recursiveFunction(index-1)
				if found == True :
					passTrouve = "".join(self.tabPass)
					return found, passTrouve
		
		return found, passTrouve
					
	#Cette fonction permet de replacer le dernier caractère de la Chaine
	def checkChar(self,index):
		found = False
		passTrouve = ""	
		for char in tabChar:
			if self.verbose:
				self.testSpeed()
			self.tabPass[index] = char
			if "".join(self.tabPass) == self.password:
				found=True
				passTrouve = "".join(self.tabPass)
				return found, passTrouve
			#print("".join(self.tabPass))
		return found, passTrouve

		
#si le fichier est lancé seul
if __name__ == '__main__' :	
	application = App()
	application.run()
	sys.exit()